<!DOCTYPE html>


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>Tutorial &mdash; Bérou 0.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/basic.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../_static/bootstrap-3.3.4/css/bootstrap.min.css" type="text/css" />
    <link rel="stylesheet" href="../_static/bootstrap-3.3.4/css/bootstrap-theme.min.css" type="text/css" />
    <link rel="stylesheet" href="../_static/bootstrap-sphinx.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '0.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/js/jquery-1.11.0.min.js"></script>
    <script type="text/javascript" src="../_static/js/jquery-fix.js"></script>
    <script type="text/javascript" src="../_static/bootstrap-3.3.4/js/bootstrap.min.js"></script>
    <script type="text/javascript" src="../_static/bootstrap-sphinx.js"></script>
    <link rel="top" title="Bérou 0.1 documentation" href="../index.html" />
    <link rel="up" title="Development" href="index.html" />
    <link rel="next" title="Deployment" href="../deployment/index.html" />
    <link rel="prev" title="How to translate my app ?" href="i18n.html" />
<meta charset='utf-8'>
<meta http-equiv='X-UA-Compatible' content='IE=edge,chrome=1'>
<meta name='viewport' content='width=device-width, initial-scale=1.0, maximum-scale=1'>
<meta name="apple-mobile-web-app-capable" content="yes">

  </head>
  <body role="document">

  <div id="navbar" class="navbar navbar-default navbar-fixed-top">
    <div class="container">
      <div class="navbar-header">
        <!-- .btn-navbar is used as the toggle for collapsed navbar content -->
        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".nav-collapse">
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </button>
        <a class="navbar-brand" href="../index.html">
          Bérou</a>
        <span class="navbar-text navbar-version pull-left"><b>0.1</b></span>
      </div>

        <div class="collapse navbar-collapse nav-collapse">
          <ul class="nav navbar-nav">
            
            
              <li class="dropdown globaltoc-container">
  <a role="button"
     id="dLabelGlobalToc"
     data-toggle="dropdown"
     data-target="#"
     href="../index.html">Site <b class="caret"></b></a>
  <ul class="dropdown-menu globaltoc"
      role="menu"
      aria-labelledby="dLabelGlobalToc"><ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="index.html">Development</a></li>
<li class="toctree-l1"><a class="reference internal" href="../deployment/index.html">Deployment</a></li>
<li class="toctree-l1"><a class="reference internal" href="../usage/index.html">Usage</a></li>
</ul>
</ul>
</li>
              
                <li class="dropdown">
  <a role="button"
     id="dLabelLocalToc"
     data-toggle="dropdown"
     data-target="#"
     href="#">Page <b class="caret"></b></a>
  <ul class="dropdown-menu localtoc"
      role="menu"
      aria-labelledby="dLabelLocalToc"><ul>
<li><a class="reference internal" href="#">Tutorial</a><ul>
<li><a class="reference internal" href="#create-a-django-app">Create a Django app</a></li>
<li><a class="reference internal" href="#urls">Urls</a></li>
<li><a class="reference internal" href="#views">Views</a></li>
<li><a class="reference internal" href="#templates">Templates</a><ul>
<li><a class="reference internal" href="#the-base-template">The base template</a></li>
<li><a class="reference internal" href="#your-first-template">Your first template</a></li>
</ul>
</li>
<li><a class="reference internal" href="#see-the-result">See the result</a><ul>
<li><a class="reference internal" href="#create-your-user-account">Create your user account</a></li>
</ul>
</li>
<li><a class="reference internal" href="#app-api">App API</a><ul>
<li><a class="reference internal" href="#define-a-logo-for-your-app">Define a logo for your app</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</ul>
</li>
              
            
            
              
                
  <li>
    <a href="i18n.html" title="Previous Chapter: How to translate my app ?"><span class="glyphicon glyphicon-chevron-left visible-sm"></span><span class="hidden-sm hidden-tablet">&laquo; How to translate...</span>
    </a>
  </li>
  <li>
    <a href="../deployment/index.html" title="Next Chapter: Deployment"><span class="glyphicon glyphicon-chevron-right visible-sm"></span><span class="hidden-sm hidden-tablet">Deployment &raquo;</span>
    </a>
  </li>
              
            
            
            
            
              <li class="hidden-sm">
<div id="sourcelink">
  <a href="../_sources/development/tutorial.txt"
     rel="nofollow">Source</a>
</div></li>
            
          </ul>

          
            
<form class="navbar-form navbar-right" action="../search.html" method="get">
 <div class="form-group">
  <input type="text" name="q" class="form-control" placeholder="Search" />
 </div>
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form>
          
        </div>
    </div>
  </div>

<div class="container">
  <div class="row">
    <div class="col-md-12">
      
  <div class="section" id="tutorial">
<h1>Tutorial<a class="headerlink" href="#tutorial" title="Permalink to this headline">¶</a></h1>
<p>In this tutorial, we will create a single page, with a single url.
This tutorial assumes you have Bérou installed.
The Django project is located in berou,
and all the commands show in this tutorial are run from this directory.</p>
<div class="highlight-python"><div class="highlight"><pre>cd berou
</pre></div>
</div>
<div class="section" id="create-a-django-app">
<h2>Create a Django app<a class="headerlink" href="#create-a-django-app" title="Permalink to this headline">¶</a></h2>
<div class="highlight-python"><div class="highlight"><pre>./manage.py startapp my_app
</pre></div>
</div>
</div>
<div class="section" id="urls">
<h2>Urls<a class="headerlink" href="#urls" title="Permalink to this headline">¶</a></h2>
<p>In order to display your first page, you will need to create some URLs.
Create a <cite>urls.py</cite> in your app directory.</p>
<div class="highlight-python"><div class="highlight"><pre><span class="kn">from</span> <span class="nn">django.conf.urls</span> <span class="kn">import</span> <span class="n">url</span>

<span class="kn">from</span> <span class="nn">my_app</span> <span class="kn">import</span> <span class="n">views</span>

<span class="n">urlpatterns</span> <span class="o">=</span> <span class="p">[</span>
    <span class="n">url</span><span class="p">(</span><span class="s">r&#39;^$&#39;</span><span class="p">,</span> <span class="n">views</span><span class="o">.</span><span class="n">MyView</span><span class="o">.</span><span class="n">as_view</span><span class="p">(),</span> <span class="n">name</span><span class="o">=</span><span class="s">&#39;my_page&#39;</span><span class="p">),</span>
<span class="p">]</span>
</pre></div>
</div>
<p>The important line is the second to last line.
It means: When the user is trying to access the root page, use MyView.
I want to use this URL later (in a template for example), so I call it &#8216;my_page&#8217;.</p>
<p>Now that we have our first URL, we need to create <cite>MyView</cite> in the views module.</p>
</div>
<div class="section" id="views">
<h2>Views<a class="headerlink" href="#views" title="Permalink to this headline">¶</a></h2>
<p>Create a <cite>views.py</cite> in your app directory.</p>
<div class="highlight-python"><div class="highlight"><pre><span class="kn">from</span> <span class="nn">django.views.generic</span> <span class="kn">import</span> <span class="n">TemplateView</span>


<span class="k">class</span> <span class="nc">MyView</span><span class="p">(</span><span class="n">TemplateView</span><span class="p">):</span>
    <span class="n">template_name</span> <span class="o">=</span> <span class="s">&#39;my_app/my_template.html&#39;</span>
</pre></div>
</div>
</div>
<div class="section" id="templates">
<h2>Templates<a class="headerlink" href="#templates" title="Permalink to this headline">¶</a></h2>
<div class="section" id="the-base-template">
<h3>The base template<a class="headerlink" href="#the-base-template" title="Permalink to this headline">¶</a></h3>
<p>The base template is the template you need to inherit from in your own templates.
It comes with the structure of the page. The structure works as follow:</p>
<div class="highlight-python"><div class="highlight"><pre>&lt;!DOCTYPE html&gt;
&lt;html&gt;
&lt;head&gt;
    &lt;link rel=&quot;stylesheet&quot; href=&quot;bootstrap.css&quot;&gt;
    &lt;script src=&quot;bootstrap.css&quot;&gt;&lt;/script&gt;
&lt;/head&gt;
&lt;body&gt;
    &lt;div class=&quot;header&quot;&gt;
        header content
    &lt;/div&gt;
    &lt;div class=&quot;container-fluid&quot;&gt;
        {% block content %}
        {% endblock content %}
    &lt;/div&gt;
    &lt;footer&gt;
        footer content
    &lt;/footer&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre></div>
</div>
<p>Note that this is just some pseudo code that is here to explain the structure and not the real code.
If you want to look what it looks like, look at: <cite>berou/berou/templates/berou/base.html</cite>.</p>
<p>As you may have noticed, Bérou uses <a class="reference external" href="http://getbootstrap.com/">bootstrap</a> for its CSS.</p>
</div>
<div class="section" id="your-first-template">
<h3>Your first template<a class="headerlink" href="#your-first-template" title="Permalink to this headline">¶</a></h3>
<p><cite>templates/my_app/my_template.html</cite></p>
<div class="highlight-python"><div class="highlight"><pre>{% extends &#39;berou/base.html&#39; %}
{% load i18n %}
{% block content %}
&lt;div class=&quot;row&quot;&gt;
    {% trans &quot;Hello world!&quot; %}
&lt;/div&gt;
{% endblock content %}
</pre></div>
</div>
<p>If you don&#8217;t understand what the <cite>{% trans &#8220;Hello world!&#8221; %}</cite> is for, I invite you to read the main page.</p>
<p>After doing this, you can install your app in Bérou.
To do so, create a file called <cite>install.py</cite> in your app folder, with the following content:</p>
<div class="highlight-python"><div class="highlight"><pre><span class="c"># -*- coding: utf-8 -*-</span>

<span class="kn">from</span> <span class="nn">django.utils.translation</span> <span class="kn">import</span> <span class="n">ugettext_lazy</span> <span class="k">as</span> <span class="n">_</span>

<span class="kn">from</span> <span class="nn">application_system</span> <span class="kn">import</span> <span class="n">models</span>


<span class="k">def</span> <span class="nf">install</span><span class="p">():</span>
    <span class="n">app</span> <span class="o">=</span> <span class="n">models</span><span class="o">.</span><span class="n">App</span><span class="p">(</span>
        <span class="n">name</span><span class="o">=</span><span class="n">__package__</span><span class="o">.</span><span class="n">capitalize</span><span class="p">(),</span>
        <span class="n">description</span><span class="o">=</span><span class="n">_</span><span class="p">(</span><span class="s">&#39;My first app&#39;</span><span class="p">),</span>
        <span class="n">package</span><span class="o">=</span><span class="n">__package__</span><span class="p">,</span>
    <span class="p">)</span>
    <span class="n">app</span><span class="o">.</span><span class="n">save</span><span class="p">()</span>
</pre></div>
</div>
<p>Note: You can perform extra things in the <cite>install</cite> function.</p>
<p>Once you have saved this file, install it like this:</p>
<div class="highlight-python"><div class="highlight"><pre>./manage.py install_app my_app
</pre></div>
</div>
</div>
</div>
<div class="section" id="see-the-result">
<h2>See the result<a class="headerlink" href="#see-the-result" title="Permalink to this headline">¶</a></h2>
<p>Start the server:</p>
<div class="highlight-python"><div class="highlight"><pre>./manage.py runserver
</pre></div>
</div>
<div class="section" id="create-your-user-account">
<h3>Create your user account<a class="headerlink" href="#create-your-user-account" title="Permalink to this headline">¶</a></h3>
<p>Go to <a class="reference external" href="http://localhost:8000/">http://localhost:8000/</a> in your browser, and register a new account.</p>
<p>In your browser, go to: <a class="reference external" href="http://localhost:8000">http://localhost:8000</a>, activate <cite>My_app</cite>
and click on it in the header of the page.</p>
<p>When you have created your account, you are invited to activate an app.
Activate your newly installed app, and click on its name
in the header bar to see your work.</p>
</div>
</div>
<div class="section" id="app-api">
<h2>App API<a class="headerlink" href="#app-api" title="Permalink to this headline">¶</a></h2>
<p>More options are available, see for yourself:</p>
<dl class="function">
<dt id="App">
<code class="descname">App</code><span class="sig-paren">(</span><em>name=None</em>, <em>description=''</em>, <em>package=None</em><span class="optional">[</span>, <em>logo=None</em><span class="optional">[</span>, <em>users=None</em><span class="optional">]</span><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#App" title="Permalink to this definition">¶</a></dt>
<dd><p>An App is a Django Model. It is used to save information about the app itself,
and also a list of users that use it.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>name</strong> (<a class="reference external" href="http://docs.python.org/library/functions.html#str" title="(in Python v2.7)"><em>str</em></a>) &#8211; The application name</li>
<li><strong>description</strong> (<a class="reference external" href="http://docs.python.org/library/functions.html#str" title="(in Python v2.7)"><em>str</em></a>) &#8211; The description of the app</li>
<li><strong>package</strong> (<a class="reference external" href="http://docs.python.org/library/functions.html#str" title="(in Python v2.7)"><em>str</em></a>) &#8211; The python package of the app. Just pass in <cite>__package__</cite></li>
<li><strong>logo</strong> (<a class="reference external" href="http://docs.python.org/library/functions.html#str" title="(in Python v2.7)"><em>str</em></a>) &#8211; The path of your logo. Use <cite>static</cite> as shown below</li>
<li><strong>users</strong> (<a class="reference external" href="http://docs.python.org/library/functions.html#list" title="(in Python v2.7)"><em>list</em></a>) &#8211; A list of users that have enabled the app. Do not override this parameter, unless you know what you are doing.</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<p>The description is the description of your application.
Users will see the app description on their home page,
as well as on their <cite>Manage my apps</cite> page.</p>
<div class="section" id="define-a-logo-for-your-app">
<h3>Define a logo for your app<a class="headerlink" href="#define-a-logo-for-your-app" title="Permalink to this headline">¶</a></h3>
<p>It is possible to define a logo for your app. It will be displayed on the home page.
In order to add it to your application, create a static folder and its subfolders:</p>
<div class="highlight-python"><div class="highlight"><pre>mkdir -p static/my_app/img/
cp my_logo.svg static/my_app/img
</pre></div>
</div>
<p>Once you have the logo in the static folder, we&#8217;ll need to update the install.py:</p>
<div class="highlight-python"><div class="highlight"><pre><span class="c"># -*- coding: utf-8 -*-</span>

<span class="kn">from</span> <span class="nn">django.utils.translation</span> <span class="kn">import</span> <span class="n">ugettext_lazy</span> <span class="k">as</span> <span class="n">_</span>
<span class="kn">from</span> <span class="nn">django.templatetags.static</span> <span class="kn">import</span> <span class="n">static</span>

<span class="kn">from</span> <span class="nn">application_system</span> <span class="kn">import</span> <span class="n">models</span>


<span class="k">def</span> <span class="nf">install</span><span class="p">():</span>
    <span class="n">app</span> <span class="o">=</span> <span class="n">models</span><span class="o">.</span><span class="n">App</span><span class="p">(</span>
        <span class="n">name</span><span class="o">=</span><span class="n">__package__</span><span class="o">.</span><span class="n">capitalize</span><span class="p">(),</span>
        <span class="n">description</span><span class="o">=</span><span class="n">_</span><span class="p">(</span><span class="s">&#39;My first app&#39;</span><span class="p">),</span>
        <span class="n">package</span><span class="o">=</span><span class="n">__package__</span><span class="p">,</span>
        <span class="n">logo</span><span class="o">=</span><span class="n">static</span><span class="p">(</span><span class="s">&#39;my_app/img/my_logo.svg&#39;</span><span class="p">),</span>
    <span class="p">)</span>
    <span class="n">app</span><span class="o">.</span><span class="n">save</span><span class="p">()</span>
</pre></div>
</div>
<p>Now you can reinstall your app:</p>
<div class="highlight-python"><div class="highlight"><pre>./manage.py install_app my_app
</pre></div>
</div>
</div>
</div>
</div>


    </div>
      
  </div>
</div>
<footer class="footer">
  <div class="container">
    <p class="pull-right">
      <a href="#">Back to top</a>
      
    </p>
    <p>
        &copy; Copyright 2015, Francois Ribemont.<br/>
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.3.1.<br/>
    </p>
  </div>
</footer>
  </body>
</html>